/* Jeff DeMaagd
	July 20, 1998 */
/* This file holds all the advanced CAM functions */

#include <stdio.h>
#include <string.h>
#include "../geom/geom.h"
#include "camprot.h"

/************************************************************************/
void read_dxf (double part_clearance)
/* this is where more fun stuff happens.  I will try to read a DXF file
for important or pertainent data */
{
	int line_count = 0, number= -1;	
	char record[32];
	struct arc a1;
	struct point p1;
	struct line_seg ls1;

	printf ("Entering read_dxf\n");
	if ((file_in == NULL) || (file_out == NULL))	{
		if (file_in == NULL)	{
			printf ("Error opening input file.\n");
		}
		if (file_out == NULL)	{
			printf ("Error opening output file.\n");
		}
	} else	{
		fscanf (file_in, "%s", record);
		line_count++;

		while (0 != strcmp ("ENTITIES", record))
		{	/* fast forward to the ENTITIES section */
			fscanf (file_in, "%s", record);
			line_count++;
		}
/*		fprintf (file_out, " %d", line_count); a debug line */

		fscanf (file_in, "%d", &number); /* 0 */
		fscanf (file_in, "%s", record);
		while ((number == 0) && ( 0 != strcmp ("ENDSEC", record)))	{
			if (0 == strcmp ("LINE", record))	{
				ls1 = read_dxf_line ();
			        cut_line (ls1, part_clearance, PLUNGE);
			} else if (0 == strcmp ("POINT", record))	{
				p1 = read_dxf_point ();
			        cut_point (p1, part_clearance, PLUNGE);
			} else if (0 == strcmp ("ARC", record))	{
				a1 = read_dxf_arc ();
				cut_arc (a1, part_clearance, PLUNGE);
			}

			number = 1; 		/* priming my skip engine */
			while (number != 0) {  /* skip to the next object */
				fscanf (file_in, "%d", &number); /* 0 */
				fscanf (file_in, "%s", record);
			}
		}

		z_pos (CLEARANCE); /* pull tool straight out of part */

	}
} /* read_dxf */

/************************************************************************/
struct line_seg read_dxf_line (void)
{
	int number;
	char record[32];
	struct line_seg ls1;

	printf ("Entering read_dxf_line\n");
	while (0 != strcmp ("AcDbLine", record))	{	
		/* fast forward to the important section */
		fscanf (file_in, "%s", record);
	}
	
	fscanf (file_in, " %d", &number); /* 10 */
	fscanf (file_in, "%lf", &ls1.p1.x);

	fscanf (file_in, " %d", &number); /* 20 */
	fscanf (file_in, "%lf", &ls1.p1.y);

	fscanf (file_in, " %d", &number); /* 30 */
	fscanf (file_in, "%lf", &ls1.p1.z);

	fscanf (file_in, " %d", &number); /* 11 */
	fscanf (file_in, "%lf", &ls1.p2.x);

	fscanf (file_in, " %d", &number); /* 21 */
	fscanf (file_in, "%lf", &ls1.p2.y);

	fscanf (file_in, " %d", &number); /* 31 */
	fscanf (file_in, "%lf", &ls1.p2.z);
		
	return (ls1);
}	/* read_dxf_line */

/************************************************************************/
struct point read_dxf_point (void)
{
	int number;
	char record[32];
	struct point p1;

	printf ("Entering read_dxf_point\n");
	while (0 != strcmp ("AcDbPoint", record))	{
		/* fast forward to the important section */
		fscanf (file_in, "%s", record);
	}
	
	fscanf (file_in, " %d", &number); /* 10 */
	fscanf (file_in, "%lf", &p1.x);

	fscanf (file_in, " %d", &number); /* 20 */
	fscanf (file_in, "%lf", &p1.y);

	fscanf (file_in, " %d", &number); /* 30 */
	fscanf (file_in, "%lf", &p1.z);
		
	return (p1);
}	/* read_dxf_point */

/************************************************************************/
struct arc read_dxf_arc (void)
{
	int number;
	char record[32];
	struct arc a1;

	printf ("Entering read_dxf_arc\n");
	while (0 != strcmp ("AcDbCircle", record))
	{	/* fast forward to the important section */
		fscanf (file_in, "%s", record);
	}
	
	fscanf (file_in, " %d", &number); /* 10 */
	fscanf (file_in, "%lf", &a1.p1.x);

	fscanf (file_in, " %d", &number); /* 20 */
	fscanf (file_in, "%lf", &a1.p1.y);

	fscanf (file_in, " %d", &number); /* 30 */
	fscanf (file_in, "%lf", &a1.p1.z);
		
	fscanf (file_in, " %d", &number); /* 40 */
	fscanf (file_in, "%lf", &a1.r1);
		
	fscanf (file_in, " %d", &number); /* 100 */
	fscanf (file_in, "%s", record);
		
	fscanf (file_in, " %d", &number); /* 50 */
	fscanf (file_in, "%lf", &a1.a1);
		
	fscanf (file_in, " %d", &number); /* 51 */
	fscanf (file_in, "%lf", &a1.a2);
		
	return (a1);
}	/* read_dxf_point */

