/*	Jeff DeMaagd
	July 20, 1998 */

#ifndef CAM_PROTO
#define CAM_PROTO

/* #include "../geom/latest/geomprot.h" */
/* This file holds all the functions prototypes */
/************************************************************************/

/* system wide variables and constants */
char cam_coolant;
char cam_debug;
char cam_verbose;
FILE *file_in, *file_out;

#define NO	0	/* I have the logically similar "constants" set to */
#define OFF	0 	/* same number so my comparisons only have to check */
#define END	0	/* once */
#define YES	1
#define ON	1
#define START	1
#define INCH	2	
#define ENGLISH		2
#define METRIC		3
#define MM		3
#define ABSOLUTE	4
#define RELATIVE	5
#define INCREMENTAL	5
#define COMPENSATED	6
#define UNCOMPENSATED	7
#define LEFT	8
#define RIGHT	9
#define X	4
#define Y	2
#define Z	1
#define XY	6
#define XZ	5
#define YZ	2
#define XYZ	7
#define CLOCKWISE		13
#define CW			13
#define COUNTERCLOCKWISE	14
#define CCW			14
#define ORIENT		15
#define TOOLCHANGE	16
#define CLEARANCE	17
#define PROGRAM		18
#define OPTIONAL	19
#define MIST		20
#define FLOOD		21
#define CLAMP		22
#define UNCLAMP		23
#define PLUNGE		24
#define RAMP		25
#define M32		32
#define M92		92
#define RAPID		25
#define LINEAR		26

/* M code functions */
void stop (char type);
void end_program_machine_on (void);
void spindle (char direction, double speed);
void tool_change (int tool);
void coolant (char setting);
void rotary_table (char setting);
void orient_spindle (void);
void machine_end_program (void);
void test_wait_channel (char channel);
void graphics (char setting);
void sweep_3D_off (void);
void sweep_3D_on (void);
void tapered_wall (void);
void rounded_wall (void);
void pocket_clear (void);
void call_subprogram (short int number, short int loops);
void end_subprogram (void);

/* miscellaneous functions */
void feed (double speed);
void angle (double degrees);
void radius (double distance);
void spindle_speed (double speed);
void loc_x (double pos);
void loc_y (double pos);
void loc_z (double pos);
void arc_cen_x (double pos);
void arc_cen_y (double pos);
void arc_cen_z (double pos);
void new_line (void);
void end_file (void);
void parm_set (unsigned short int parm_num, double parm_val);

/* G code functions */
void arc (char direction);
void set_data (char action);
void set_pos_mode (char type);
void exact_stop (void);
void clear_flz (void);
void dwell (double time);
void set_units (char type);
void safe_zone (char set);
void z_pos (char location);
void comp (char type);
void scale_cancel (void);
void scale_set (struct point scale_cen, vector_t scale_mag);

/* advanced programming functions */
short int start_program (char units, double part_clearance);
void end_program (void);
char cut_line (struct line_seg ls1, double part_clearance, char z_down);
char cut_point (struct point p1, double part_clearance, char z_down);
char cut_arc (struct arc a1, double part_clearance, char z_down);
void cut_3d_triangle (	struct triangle t1,	double cut_fraction, 
			double tool_dia,	double part_clearance, 
			double surface_z,	double cut_z_inc, 
			char cut_comp,		char z_down);
void cut_triangle (struct triangle t1, double cut_fraction, double tool_dia, double part_clearance, char z_down);
void go_to_point (char pos_type, char coord_mask, struct point p1);
void arc_motion (struct point center_pt, double radius, double end_angle, char direction);

/* DXF program instructions */
void read_dxf (double part_clearance);
struct line_seg read_dxf_line (void);
struct point read_dxf_point (void);
struct arc read_dxf_arc (void);

#endif
